--[[
WTF did i type in this? if you can understand this please tell me
]]--
------------------ VARIABLES -----------

local PRAddonEnabled --- to stop abuse
local PRTrigger --- The Trigger holder
local PRAddonDelayCheck = 0
local LastRunDelayTime = 0
local PRLockOutTime -- trigger to stop abuse default 15
local PRChannel --- triggers for whispers or guild or say
local PRTriggerLength --- gets length of triggers
local PRCheckEnabled --- hold wether the checkbox is checked or not
PRCommandBox:SetJustifyH("CENTER")
PRTimeOutBox:SetJustifyH("CENTER")
PROpened = false

----------------------------------------

---- Register Frames ---
local PRframe = CreateFrame('FRAME')
PRframe:SetScript("OnEvent", function(the, event, ...)
	PREvents[event](...)
end)
PRframe:RegisterEvent("CHAT_MSG_GUILD")
PRframe:RegisterEvent("ADDON_LOADED")
PRframe:RegisterEvent("CHAT_MSG_WHISPER")
PRframe:RegisterEvent("CHAT_MSG_SAY")
PREvents = {}
-------

----- ADDDON LOADED ---

function PREvents.ADDON_LOADED()
	if not PriceReplyDB then
		PriceReplyDB = {}
	end
	if not PriceReplyDB.PRAddonEnabled then
		PriceReplyDB.PRAddonEnabled = "Enabled"
	end
	if not PriceReplyDB.PRTrigger then
		PriceReplyDB.PRTrigger = "PR: "
	end
	if not PriceReplyDB.PRLockOutTime then
		PriceReplyDB.PRLockOutTime = 15
	end
	if not PriceReplyDB.PRChannel then
		PriceReplyDB.PRChannel = "WHISPER"
	end

	PRChannel = PriceReplyDB.PRChannel
	PRLockOutTime = PriceReplyDB.PRLockOutTime
	PRTrigger = PriceReplyDB.PRTrigger
	PRTriggerLength = string.len(PRTrigger)
	PRAddonEnabled = PriceReplyDB.PRAddonEnabled
	PRframe:UnregisterEvent("ADDON_LOADED")
end
------------------------------

---- slash handlers ---

SLASH_PRICEREPLY1, SLASH_PRICEREPLY2 = '/pricereply', '/pr'

function SlashCmdList.PRICEREPLY(msg)
	if PROpened == false then
		PROpened = true
		PriceReply:Show()
	elseif PROpened == true then
		PROpened = false
		PriceReply:Hide()
	end
end

--------------------------------

--- Handle events --

---------------- Whisper event --------------
function PREvents.CHAT_MSG_WHISPER(MSG,Auth)
	PRAddonEnabled = PriceReplyDB.PRAddonEnabled --- check it
	local MSGTRIG = string.sub(MSG ,0 ,PRTriggerLength)
	local MSG = MSG
	local Auth = Auth
	--- Price Get --
	local PRPriceMarket = TSMAPI:GetItemValue(MSG,"DBMarket")
	local PRPriceMin = TSMAPI:GetItemValue(MSG,"DBMinBuyout")
	-- time functions ---
	local Current = time()
	local Past = TSMAPI:GetData("lastCompleteScanTime")
	local PRTimeLastScannedHours = floor(PR_ConvertTime(Current, Past) / 3600)-- 1 min is 60 seconds and 60 minutes in 1 hour so 60 * 60 = 3600
	local PRTimeLastScannedMinutes = floor(PR_ConvertTime(Current, Past) / 60) -- convert minues
	local LastRunCheck = PR_LastRunCheck()
	-----------------------------------------------------------------

	if string.find(MSG,PRTrigger) and PRPriceMarket ~= nil and PRPriceMin ~= nil and PRAddonEnabled =="Enabled" and LastRunCheck == "Yes" then
		-- Market Prices --
		local MktGOLD = PR_ConvertPriceToMoney(PRPriceMarket,"Gold")
		local MktSILVER = PR_ConvertPriceToMoney(PRPriceMarket,"Silver")
		local MktCOPPER = PR_ConvertPriceToMoney(PRPriceMarket,"Copper")

		--- Minimum Price --
		local MinGOLD = PR_ConvertPriceToMoney(PRPriceMin,"Gold")
		local MinSILVER = PR_ConvertPriceToMoney(PRPriceMin,"Silver")
		local MinCOPPER = PR_ConvertPriceToMoney(PRPriceMin,"Copper")

		--- Message to send and channel--
		local PRTHEMESSAGE = ("Price Reply: Market Price: "..MktGOLD.."g"..MktSILVER.."s"..MktCOPPER.."c".." / ".."Current Min buyout: "..MinGOLD.."g"..MinSILVER.."s"..MinCOPPER.."c".." / ".."Last scanned: "..PRTimeLastScannedHours.." Hrs "..PRTimeLastScannedMinutes.." Mins Ago")
		--print(PRTHEMESSAGE)
		SendChatMessage(PRTHEMESSAGE, PRChannel, "Common", Auth)

		---
		LastRunDelayTime = time() --- gets the current time
		----
	end
end

----- Guild event ----
function PREvents.CHAT_MSG_GUILD(MSG,Auth)
	PRAddonEnabled = PriceReplyDB.PRAddonEnabled --- check it
	local MSGTRIG = string.sub(MSG ,0 ,PRTriggerLength)
	local MSG = MSG
	local Auth = Auth
	--- Price Get --
	local PRPriceMarket = TSMAPI:GetItemValue(MSG,"DBMarket")
	local PRPriceMin = TSMAPI:GetItemValue(MSG,"DBMinBuyout")
	-- time functions ---
	local Current = time()
	local Past = TSMAPI:GetData("lastCompleteScanTime")
	local PRTimeLastScannedHours = floor(PR_ConvertTime(Current, Past) / 3600)-- 1 min is 60 seconds and 60 minutes in 1 hour so 60 * 60 = 3600
	local PRTimeLastScannedMinutes = floor(PR_ConvertTime(Current, Past) / 60) -- convert minues
	local LastRunCheck = PR_LastRunCheck()
	-----------------------------------------------------------------

	if string.find(MSG,PRTrigger) and PRPriceMarket ~= nil and PRPriceMin ~= nil and PRAddonEnabled =="Enabled" and LastRunCheck == "Yes" then
		-- Market Prices --
		local MktGOLD = PR_ConvertPriceToMoney(PRPriceMarket,"Gold")
		local MktSILVER = PR_ConvertPriceToMoney(PRPriceMarket,"Silver")
		local MktCOPPER = PR_ConvertPriceToMoney(PRPriceMarket,"Copper")

		--- Minimum Price --
		local MinGOLD = PR_ConvertPriceToMoney(PRPriceMin,"Gold")
		local MinSILVER = PR_ConvertPriceToMoney(PRPriceMin,"Silver")
		local MinCOPPER = PR_ConvertPriceToMoney(PRPriceMin,"Copper")

		--- Message to send and channel--
		local PRTHEMESSAGE = ("Price Reply: Market Price: "..MktGOLD.."g"..MktSILVER.."s"..MktCOPPER.."c".." / ".."Current Min buyout: "..MinGOLD.."g"..MinSILVER.."s"..MinCOPPER.."c".." / ".."Last scanned: "..PRTimeLastScannedHours.." Hrs "..PRTimeLastScannedMinutes.." Mins Ago")
		--print(PRTHEMESSAGE)
		SendChatMessage(PRTHEMESSAGE, PRChannel, "Common", Auth)

		---
		LastRunDelayTime = time() --- gets the current time
		----
	end
end

---- /say ---
function PREvents.CHAT_MSG_SAY(MSG,Auth)
	PRAddonEnabled = PriceReplyDB.PRAddonEnabled --- check it
	local MSGTRIG = string.sub(MSG ,0 ,PRTriggerLength)
	local MSG = MSG
	local Auth = Auth
	--- Price Get --
	local PRPriceMarket = TSMAPI:GetItemValue(MSG,"DBMarket")
	local PRPriceMin = TSMAPI:GetItemValue(MSG,"DBMinBuyout")
	-- time functions ---
	local Current = time()
	local Past = TSMAPI:GetData("lastCompleteScanTime")
	local PRTimeLastScannedHours = floor(PR_ConvertTime(Current, Past) / 3600)-- 1 min is 60 seconds and 60 minutes in 1 hour so 60 * 60 = 3600
	local PRTimeLastScannedMinutes = floor(PR_ConvertTime(Current, Past) / 60) -- convert minues
	local LastRunCheck = PR_LastRunCheck()
	-----------------------------------------------------------------

	if string.find(MSGTRIG,PRTrigger) and PRPriceMarket ~= nil and PRPriceMin ~= nil and PRAddonEnabled =="Enabled" and LastRunCheck == "Yes" then
		-- Market Prices --
		local MktGOLD = PR_ConvertPriceToMoney(PRPriceMarket,"Gold")
		local MktSILVER = PR_ConvertPriceToMoney(PRPriceMarket,"Silver")
		local MktCOPPER = PR_ConvertPriceToMoney(PRPriceMarket,"Copper")

		--- Minimum Price --
		local MinGOLD = PR_ConvertPriceToMoney(PRPriceMin,"Gold")
		local MinSILVER = PR_ConvertPriceToMoney(PRPriceMin,"Silver")
		local MinCOPPER = PR_ConvertPriceToMoney(PRPriceMin,"Copper")

		--- Message to send and channel--
		local PRTHEMESSAGE = ("Price Reply: Market Price: "..MktGOLD.."g"..MktSILVER.."s"..MktCOPPER.."c".." / ".."Current Min buyout: "..MinGOLD.."g"..MinSILVER.."s"..MinCOPPER.."c".." / ".."Last scanned: "..PRTimeLastScannedHours.." Hrs "..PRTimeLastScannedMinutes.." Mins Ago")
		--print(PRTHEMESSAGE)
		SendChatMessage(PRTHEMESSAGE, PRChannel, "Common", Auth)

		---
		LastRunDelayTime = time() --- gets the current time
		----
	end
end

-------------------------- Useful Functions --------------
function PR_ConvertPriceToMoney(PRICE,TYPE)
	local GOLD
	local SILVER
	local COPPER
	if PRICE == nil then Price = 0 end -- make sure it is a number
	if TYPE == "Gold" then
		GOLD = floor(PRICE/10000) -- divide price by 10000 to decide gold and floor it to get rid of hang overs
		return GOLD or 0 -- Make sure it always returns a number
	elseif TYPE == "Silver" then
		SILVER = floor(strsub(PRICE, -4) / 100) -- strsub will only see the last 4 numbers of a sentece and divide it by 100
		return SILVER or 0
	elseif TYPE == "Copper" then
		COPPER = floor(strsub(PRICE, -2)) -- no division needed for 10th's
		return COPPER or 0
	end
end
------
function PR_ConvertTime(Current, Past)
	local Current = Current
	local Past = Past
	local Difference = (Current - Past)
	return Difference
end
----------
function PR_LastRunCheck()
	local Current = time()
	local Past = (LastRunDelayTime + PRLockOutTime)
	if Current > Past then
		return "Yes"
	else
		return "No"
	end
end
---------------
function PR_SetVariables()
	PriceReplyDB.PRTrigger = PRCommandBox:GetText()
	PRTrigger = PRCommandBox:GetText()
	PRLockOutTime = PRTimeOutBox:GetText()
	PRTriggerLength = string.len(PRTrigger)
	PRCheckEnabled = PREnableDisable:GetChecked()
	PROpened = false

	if PRCheckEnabled == 1 then
		PRAddonEnabled = "Enabled"
		PriceReplyDB.PRAddonEnabled = PRAddonEnabled
	elseif PRCheckEnabled == nil then
		PRAddonEnabled = "Disabled"
		PriceReplyDB.PRAddonEnabled = PRAddonEnabled
	end

	PriceReplyDB.PRLockOutTime = PRLockOutTime
	PriceReplyDB.PRTrigger = PRTrigger

end
-----------
function PR_LoadVariables()
	PRChannel = PriceReplyDB.PRChannel
	PRLockOutTime = PriceReplyDB.PRLockOutTime
	PRTrigger = PriceReplyDB.PRTrigger
	PRAddonEnabled = PriceReplyDB.PRAddonEnabled

	if PRAddonEnabled == "Enabled" then
		PREnableDisable:SetChecked(true)
	elseif PRAddonEnabled == "Disabled" then
		PREnableDisable:SetChecked(false)
	end

	PRTimeOutBox:SetText(PRLockOutTime)
	PRCommandBox:SetText(PRTrigger)

end
--------------
